# Usage: R --no-save --slave --args <PID> <SPECTRUM_SUMMARY_DIR> <REPEAT_THRESHOLD> <CONSECUTIVE_FLAG> <MAPQ> <T_TYPE> <C_TYPE> <G_TYPE> <J_TYPE> <PLOT_FILE_FORMAT> < plot_repeat_frequency_intratelomeric.R
# Description: Makes a histograms of the telomere repeats per intratelomeric read in the tumor and control sample

# Copyright 2015 Lina Sieverling

# This file is part of TelomereHunter.

# TelomereHunter is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# TelomereHunter is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with TelomereHunter.  If not, see <http://www.gnu.org/licenses/>.


# get commandline arguments
commandArgs = commandArgs()
pid = commandArgs[5]
spectrum_dir = paste(commandArgs[6], "/", pid, "/", sep="")
repeat_threshold = commandArgs[7]
consecutive_flag = commandArgs[8]
mapq_threshold = commandArgs[9]
repeat_types = commandArgs[10]
plot_file_format = commandArgs[11]

library(ggplot2)
library(grid)
library(gridExtra)

if (consecutive_flag == "True"){
  count_type = "consecutive"
}else{
  count_type = "non-consecutive"
}

if (plot_file_format=="all"){
  plot_file_format=c("pdf", "png", "svg")
}


frequency_table_file_T = paste0(spectrum_dir, "/tumor_TelomerCnt_", pid, "/", pid, "_repeat_frequency_per_intratelomeric_read.tsv")


colors = c() 

if (file.exists(frequency_table_file_T)){
  colors = c(colors, "maroon2") 
  frequency_table_T = read.table(frequency_table_file_T, header=TRUE)
  frequency_table_T$sample="Tumor"
  frequency_table_T$percent = frequency_table_T$count / sum(frequency_table_T$count) * 100
  frequency_table_T$percent_cumulative = cumsum(frequency_table_T$percent)
  #frequency_table_T$percent_cumulative = rev(cumsum(rev(frequency_table_T$percent)))
}else{
  frequency_table_T = matrix(, nrow = 0, ncol = 5)
}


frequency_table_file_C = paste0(spectrum_dir, "/control_TelomerCnt_", pid, "/", pid, "_repeat_frequency_per_intratelomeric_read.tsv")

if (file.exists(frequency_table_file_C)){
  colors = c(colors, "turquoise3") 
  frequency_table_C = read.table(frequency_table_file_C, header=TRUE)
  frequency_table_C$sample="Control"
  frequency_table_C$percent = frequency_table_C$count / sum(frequency_table_C$count) * 100
  frequency_table_C$percent_cumulative = cumsum(frequency_table_C$percent)
  #frequency_table_C$percent_cumulative = rev(cumsum(rev(frequency_table_C$percent)))
}else{
  frequency_table_C = matrix(, nrow = 0, ncol = 5)
}


df = data.frame(rbind(as.matrix(frequency_table_T),as.matrix(frequency_table_C)))
df$sample = factor(df$sample, levels=c("Tumor", "Control"))
df$number_repeats = as.numeric(levels(df$number_repeats))[df$number_repeats]
df$percent = as.numeric(levels(df$percent))[df$percent]
df$percent_cumulative = as.numeric(levels(df$percent_cumulative))[df$percent_cumulative]

if (nchar(repeat_types) < 43){
  filtering_criteria = paste0("Filtering Criteria: ",
                              repeat_threshold, " ", count_type, " repeats",
                              ", mapq threshold = ", mapq_threshold,
                              ", repeat types = ", repeat_types)
}else{
  filtering_criteria = paste0("Filtering Criteria: ",
                              repeat_threshold, " ", count_type, " repeats",
                              ", mapq threshold = ", mapq_threshold,
                              "\nrepeat types = ", repeat_types)
}


plot_dir= paste0(spectrum_dir, "plots/")

if (!(file.exists(plot_dir))){
  dir.create(plot_dir, recursive=TRUE)
}



plot_file = paste0(plot_dir, pid, "_hist_telomere_repeats_per_intratelomeric_read")

for (plot_type in plot_file_format){
  
  if (plot_type=="png"){png(paste0(plot_file,".png"), width=30, height=25, units="cm", res=300)}     
  if (plot_type=="pdf"){pdf(paste0(plot_file,".pdf"), width=30*0.4, height=25*0.4)}
  if (plot_type=="svg"){svg(paste0(plot_file, ".svg"), width=30/2.56, height=25/2.56)}
  
  # make histogram
  p_hist = ggplot(df, aes(x=number_repeats, y=percent)) +
    geom_bar(stat = "identity") +
    facet_wrap(~ sample) +
    theme(plot.title = element_text(face="bold")) +
    xlab("Number of Repeats") +
    ylab("Percent of Intratelomeric Reads")
  
  p_hist_text = arrangeGrob(p_hist, sub = textGrob(filtering_criteria, vjust=0.1, gp = gpar(fontsize = 12)))
  
  
  #make cumulative line plot
  p_cum = ggplot(df, aes(x=number_repeats, y=percent_cumulative, group=sample)) +
    geom_line(aes(colour = sample)) +
    ggtitle(paste0(pid, ": Frequency of Telomere Repeat Occurrences in Intratelomeric Reads")) +
    theme(plot.title = element_text(face="bold")) +
    scale_color_manual(values=colors) +
    theme(legend.title=element_blank()) +
    #theme(legend.position="top") +
    theme(legend.justification=c(0,-2.3), legend.position=c(0,0)) +
    xlab("Number of Repeats") +
    ylab("Percent (Cumulative)")
  
  final_plot=arrangeGrob(p_cum, p_hist_text, ncol=1, heights=c(0.4, 0.6))
  
  #print(final_plot)
  grid::grid.draw(final_plot)   #prevent blank page in pdf file
  
  invisible(dev.off())
}

# Usage: R --no-save --slave --args <FUNCTION_FILE> <PID> <OUTPUT_DIR> <PLOT_FILE_FORMAT> <GC_LOWER_LIMIT> <GC_UPPER_LIMIT> < plot_gc_content.R
# Description: Makes a summary plot of the GC content per read for all reads and for intratelomeric reads in the tumor and control sample

# Copyright 2015 Lina Sieverling

# This file is part of TelomereHunter.

# TelomereHunter is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# TelomereHunter is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with TelomereHunter.  If not, see <http://www.gnu.org/licenses/>.


# get commandline arguments
commandArgs = commandArgs()
pipeline_dir = commandArgs[5]
pid = commandArgs[6]
out_dir = paste0(commandArgs[7], "/", pid, "/")
plot_file_format = commandArgs[8]
gc_lower_limit = as.numeric(commandArgs[9])
gc_upper_limit = as.numeric(commandArgs[10])

source(file.path(pipeline_dir, "functions_for_plots.R"))

if (plot_file_format=="all"){
  plot_file_format=c("pdf", "png", "svg")
}

colors = c("maroon2", "turquoise3")
names(colors) = c("tumor", "control")

samples = c()
df_all = data.frame(gc_content_percent=c(0:100))
df_intratel = data.frame(gc_content_percent=c(0:100))

# get gc content tables
gc_content_file_T = paste0(out_dir, "/tumor_TelomerCnt_", pid, "/", pid, "_tumor_gc_content.tsv")
gc_content_file_C = paste0(out_dir, "/control_TelomerCnt_", pid, "/", pid, "_control_gc_content.tsv")
gc_content_file_intratel_T = paste0(out_dir, "/tumor_TelomerCnt_", pid, "/", pid, "_intratelomeric_tumor_gc_content.tsv")
gc_content_file_intratel_C = paste0(out_dir, "/control_TelomerCnt_", pid, "/", pid, "_intratelomeric_control_gc_content.tsv")

if (file.exists(gc_content_file_T)){
  samples=c(samples, "tumor")
   
  gc_content_T = read.table(gc_content_file_T, header=TRUE)
  gc_content_intratel_T = read.table(gc_content_file_intratel_T, header=TRUE)
  
  # add percentage of reads to gc content tables
  gc_content_T$fraction_of_reads = gc_content_T$read_count/sum(as.numeric(gc_content_T$read_count))
  gc_content_intratel_T$fraction_of_reads = gc_content_intratel_T$read_count/sum(as.numeric(gc_content_intratel_T$read_count))
  df_all$tumor = gc_content_T$fraction_of_reads
  df_intratel$tumor = gc_content_intratel_T$fraction_of_reads
}


if(file.exists(gc_content_file_C)){
  samples=c(samples, "control")
    
  gc_content_C = read.table(gc_content_file_C, header=TRUE)
  gc_content_intratel_C = read.table(gc_content_file_intratel_C, header=TRUE)
  
  # add percentage of reads to gc content tables
  gc_content_C$fraction_of_reads = gc_content_C$read_count/sum(as.numeric(gc_content_C$read_count))
  gc_content_intratel_C$fraction_of_reads = gc_content_intratel_C$read_count/sum(as.numeric(gc_content_intratel_C$read_count)) 
  df_all$control = gc_content_C$fraction_of_reads
  df_intratel$control = gc_content_intratel_C$fraction_of_reads
}


dfm_all = melt(df_all, id.var = c("gc_content_percent"), variable.name="sample", value.name="fraction_of_reads")
dfm_intratel = melt(df_intratel, id.var = c("gc_content_percent"), variable.name="sample", value.name="fraction_of_reads")

gc_lower_limit = gc_bins=c(gc_lower_limit:gc_upper_limit)


#################
### make plot ###
#################

plot_dir = file.path(out_dir, "plots")
plot_file_prefix = paste0(plot_dir, "/",  pid, "_gc_content")

if (!(file.exists(plot_dir))){dir.create(plot_dir, recursive=TRUE)}


#plot for all reads
plot_all = ggplot(dfm_all, aes(gc_content_percent, fraction_of_reads, group=sample, color = sample)) +
  annotate("rect", xmin = gc_bins-0.5, xmax = gc_bins+0.5, ymin = 0, ymax = max(dfm_all$fraction_of_reads), alpha=0.5, fill="grey") +
  geom_line() +
  theme(legend.title=element_blank()) +
  ggtitle("All Reads") +
  xlab("GC Content [%]") +
  ylab("Fraction of Reads") +
  scale_color_manual(values=colors[samples]) +
  annotate("text", x = min(gc_upper_limit, 88), y = max(dfm_all$fraction_of_reads), label = "Bins used for \nGC correction", color="grey40", size=4, hjust = 0, vjust=2)


#plot for intratelomeric reads 
plot_intratel = ggplot(dfm_intratel, aes(gc_content_percent, fraction_of_reads, group=sample, color = sample)) +
  geom_line() +
  ggtitle("Intratelomeric Reads") +
  scale_color_manual(values=colors[samples]) +
  xlab("GC Content [%]") +
  ylab("Fraction of Reads")

#combine plots
grid_arrange_shared_legend(plot_list=list(plot_all, plot_intratel), plot_file_format=plot_file_format, title=paste0(pid, ": GC Content"), plot_file_prefix=plot_file_prefix)

# Usage: R --no-save --slave --args <FUNCTION_DIR> <PID> <SPECTRUM_SUMMARY_DIR> <REPEAT_THRESHOLD> <CONSECUTIVE_FLAG> <MAPQ> <PLOT_FILE_FORMAT> <GC_LOWER_LIMIT> <GC_UPPER_LIMIT> < plot_tel_content.R
# Description: makes a bar plot of the number of intratelomeric reads (per million reads) in the tumor and control sample.

# Copyright 2015 Lina Sieverling

# This file is part of TelomereHunter.

# TelomereHunter is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# TelomereHunter is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with TelomereHunter.  If not, see <http://www.gnu.org/licenses/>.


# get commandline arguments
commandArgs = commandArgs()
pipeline_dir = commandArgs[5]
pid = commandArgs[6]
spectrum_dir = paste0(commandArgs[7], "/", pid, "/")
repeat_threshold = commandArgs[8]
consecutive_flag = commandArgs[9]
mapq_threshold = commandArgs[10]
plot_reverse_complement = commandArgs[11]
plot_file_format = commandArgs[12]
gc_lower_limit = as.numeric(commandArgs[13])
gc_upper_limit = as.numeric(commandArgs[14])


source(file.path(pipeline_dir, "/functions_for_plots.R"))

if (consecutive_flag == "True"){
  count_type = "Consecutive"
}else{
  count_type = "Non-consecutive"
}

if (plot_reverse_complement == "True"){
  plot_reverse_complement = TRUE
}else{
  plot_reverse_complement = FALSE
}

if (plot_file_format=="all"){
  plot_file_format=c("pdf", "png", "svg")
}


spectrum_tumor_file = paste0(spectrum_dir, "/tumor_TelomerCnt_", pid,"/", pid, ".spectrum")
spectrum_control_file = paste0(spectrum_dir, "/control_TelomerCnt_", pid,"/", pid, ".spectrum")

samples = c()
if (file.exists(spectrum_tumor_file)){samples = c(samples, "tumor"); names(samples)[samples=="tumor"]="Tumor"}
if (file.exists(spectrum_control_file)){samples = c(samples, "control"); names(samples)[samples=="control"]="Control"}

heights_samples_list = list()
for (sample in samples){
  #get spectrum
  spectrum = read.table(paste0(spectrum_dir, "/", sample, "_TelomerCnt_", pid,"/", pid, ".spectrum"), header=TRUE, comment.char="")
  spectrum = spectrum[spectrum$chr=="unmapped",]
  
  #get gc corrected telomere content
  summary = read.table(paste0(spectrum_dir, "/", sample, "_TelomerCnt_", pid,"/", pid, "_", sample, "_summary.tsv"), header=TRUE, sep="\t")
  tel_content = summary$tel_content
  
  #get relative telomere repeat type occurrences in telomere content
  spectrum[ ,4:ncol(spectrum)] = spectrum[ ,4:ncol(spectrum)] / sum(spectrum[ ,4:ncol(spectrum)]) * tel_content
  
  height = t(spectrum[ ,4:ncol(spectrum)])
  colnames(height) = names(samples)[samples==sample]
  
  heights_samples_list[[sample]] = height
}

if (length(samples)==2){
  height = cbind(heights_samples_list[[1]], heights_samples_list[[2]])
}else{
  height = heights_samples_list[[1]]
}


plot_dir = file.path(spectrum_dir, "plots")
if (!(file.exists(plot_dir))){dir.create(plot_dir, recursive=TRUE)}

plot_file_prefix = paste0(plot_dir,"/", pid, "_telomere_content")

barplot_repeattype(height=height,
                   width=14,
                   plot_file_prefix=plot_file_prefix,
                   plot_file_format=plot_file_format, 
                   main=paste0(pid,": GC Corrected Telomere Content"),
                   ylab=paste0("Telomere Content\n(Intratelomeric Reads per Million Reads with GC Content of ", gc_lower_limit, "-", gc_upper_limit, "%)"),
                   plot_reverse_complement=plot_reverse_complement,
                   cex.main=1,
                   repeat_threshold=repeat_threshold, count_type=count_type, mapq_threshold=mapq_threshold, 
                   axis=FALSE, axis_simple=TRUE, xlas=1, tick=FALSE, cex.axis=0.85, cex.lab=0.9, inset_legend=c(-0.63,0), cex.names=0.9) 

# Usage: R --no-save --slave --args <FUNCTION_DIR> <PID> <SPECTRUM_SUMMARY_DIR> <REPEAT_THRESHOLD> <CONSECUTIVE_FLAG> <MAPQ> <BANDING_FILE> <PLOT_FILE_FORMAT> < plot_spectrum.R
# Description: Makes a bar plot for each chromosome. The chromosome bands are plotted on the x-axis and the specific telomere reads per million bases 
#              and per billion reads are plotted on the y-axis. Attention: the "junction bands" are not divided by band length (for these bands
#              the y-axis is "specific telomere reads per billion reads"), so the scaling is not correct in comparison to "normal" bands!!! 

# Copyright 2015 Lina Sieverling, Philip Ginsbach, Lars Feuerbach

# This file is part of TelomereHunter.

# TelomereHunter is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# TelomereHunter is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with TelomereHunter.  If not, see <http://www.gnu.org/licenses/>.

# get commandline arguments
commandArgs = commandArgs()
pipeline_dir = commandArgs[5]
pid = commandArgs[6]
spectrum_dir = paste0(commandArgs[7], "/", pid, "/")
repeat_threshold = commandArgs[8]
consecutive_flag = commandArgs[9]
mapq_threshold = commandArgs[10]
banding_file = commandArgs[11]
plot_reverse_complement = commandArgs[12]
plot_file_format = commandArgs[13]


if (consecutive_flag == "True"){
  count_type = "Consecutive"
}else{
  count_type = "Non-consecutive"
}

if (plot_reverse_complement == "True"){
  plot_reverse_complement = TRUE
}else{
  plot_reverse_complement = FALSE
}

if (plot_file_format=="all"){
  plot_file_format=c("pdf", "png", "svg")
}

source(file.path(pipeline_dir, "/functions_for_plots.R"))

# get samples
spectrum_tumor_file = paste0(spectrum_dir, "/tumor_TelomerCnt_", pid,"/", pid, ".spectrum")
spectrum_control_file = paste0(spectrum_dir, "/control_TelomerCnt_", pid,"/", pid, ".spectrum")

samples = c()
if (file.exists(spectrum_tumor_file)){samples = c(samples, "tumor"); names(samples)[samples=="tumor"]="Tumor"}
if (file.exists(spectrum_control_file)){samples = c(samples, "control"); names(samples)[samples=="control"]="Control"}


# get band lengths
band_info = read.table(banding_file)
colnames(band_info) = c("chr", "start", "end", "band_name", "stain")
band_info[,"chr"] = gsub("chr", "", band_info[,1])
band_info[,"length"] = band_info[,"end"] - band_info[,"start"]

# get plot directory
plot_dir = file.path(spectrum_dir, "plots")
if (!(file.exists(plot_dir))){dir.create(plot_dir, recursive=TRUE)}



spectrum_list = list()

for (sample in samples){
  #get spectrum
  spectrum = read.table(paste0(spectrum_dir, "/",sample, "_TelomerCnt_", pid, "/", pid, ".spectrum"), header=TRUE, comment.char="")
 
  # get total number of reads 
  read_count_file = paste0(spectrum_dir, "/",sample, "_TelomerCnt_", pid, "/", pid, "_readcount.tsv")
  readcount = read.table(read_count_file, header=TRUE, comment.char="")
  total_reads = sum(as.numeric(readcount$reads))
    
  #normalize
  spectrum[ ,4:ncol(spectrum)] = spectrum[ ,4:ncol(spectrum)] * (spectrum$reads_with_pattern / apply(spectrum[ ,4:ncol(spectrum)], 1,sum))
  spectrum[ ,4:ncol(spectrum)] = spectrum[ ,4:ncol(spectrum)]*1000000000 / total_reads
  
  spectrum_list[[sample]] = spectrum
}
  
  
for (chr in c(1:22, "X", "Y")){
  
  spectrum_chr_list =list()
  
  for (sample in samples){
    spectrum = spectrum_list[[sample]]
    spectrum_chr = spectrum[spectrum$chr==chr,]
        
    #normalize by band length
    band_info_chr = band_info[band_info$chr==chr,]
    spectrum_chr[2:(nrow(spectrum_chr)-1),3:ncol(spectrum_chr)] = spectrum_chr[2:(nrow(spectrum_chr)-1),3:ncol(spectrum_chr)] *(1000000/ band_info_chr$length) 
    
    height = t(spectrum_chr[ ,4:ncol(spectrum_chr)])
    spectrum_chr_list[[sample]] = spectrum_chr
  }
  
  bands=spectrum_chr_list[[1]][ , "band"]
  
  if (length(samples)==2){
    height = zipFastener(t(spectrum_chr_list[["tumor"]][ ,4:ncol(spectrum_chr)]), t(spectrum_chr_list[["control"]][ ,4:ncol(spectrum_chr)]))
    sub_title = "Left: Tumor, Right: Control"
    axis=TRUE
    axis_simple=FALSE
  }else{
    height = t(spectrum_chr_list[[1]][ ,4:ncol(spectrum_chr)])
    sub_title = paste0(names(samples), " Sample")
    axis=FALSE
    axis_simple=TRUE
  }
  
  colnames(height)=NULL
  
  main = paste0(pid,": Telomere Repeat Types in Chr", chr)
  plot_file_prefix = paste0(plot_dir,"/", pid, "_", chr)
  
  barplot_repeattype(height=height,
                     plot_file_prefix=plot_file_prefix, plot_file_format=plot_file_format, width=28, mar=c(5.1, 5.1, 5.1, 9.3),
                     main=main, ylab="Normalized Number of Telomere Reads", #bands: Telomere Reads (per Million Bases and per Billion Reads), junctions: Telomere Reads (per Billion Reads)
                     plot_reverse_complement=plot_reverse_complement,
                     repeat_threshold=repeat_threshold, count_type=count_type, mapq_threshold=mapq_threshold,
                     inset_legend=c(-0.18,0),
                     axis=axis, axis_simple=axis_simple, labels=bands, cex.axis=0.75, cex.lab=0.9, sub_title=sub_title) 
}

  
  
  

# Copyright 2015 Lina Sieverling

# This file is part of TelomereHunter.

# TelomereHunter is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# TelomereHunter is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with TelomereHunter.  If not, see <http://www.gnu.org/licenses/>.



#check if R libraries are installed, otherwise install them
pkgTest <- function(x){
    if (!require(x,character.only = TRUE)){
      install.packages(x,dep=TRUE)
      if(!require(x,character.only = TRUE)) stop(paste("R Package\"", x, "\"not found"))
    }
  }


for (library in c('ggplot2', 'reshape2', 'grid', 'gridExtra', 'RColorBrewer')){
  pkgTest(library)
}

# Usage: R --no-save --slave --args <FUNCTION_DIR> <PID> <SPECTRUM_SUMMARY_DIR> <REPEAT_THRESHOLD> <CONSECUTIVE_FLAG> <MAPQ> <PLOT_FILE_FORMAT> < plot_spectrum_summary.R
# Description: Makes a bar plot of the number of telomere reads (per million reads) in the different fractions
#               of the tumor and/or control sample.

# Copyright 2015 Lina Sieverling

# This file is part of TelomereHunter.

# TelomereHunter is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# TelomereHunter is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with TelomereHunter.  If not, see <http://www.gnu.org/licenses/>.



# get commandline arguments
commandArgs = commandArgs()
pipeline_dir = commandArgs[5]
pid = commandArgs[6]
spectrum_dir = paste0(commandArgs[7], "/", pid, "/")
repeat_threshold = commandArgs[8]
consecutive_flag = commandArgs[9]
mapq_threshold = commandArgs[10]
plot_reverse_complement = commandArgs[11]
plot_file_format = commandArgs[12]

source(file.path(pipeline_dir, "/functions_for_plots.R"))

if (consecutive_flag == "True"){
  count_type = "Consecutive"
}else{
  count_type = "Non-consecutive"
}

if (plot_reverse_complement == "True"){
  plot_reverse_complement = TRUE
}else{
  plot_reverse_complement = FALSE
}

if (plot_file_format=="all"){
  plot_file_format=c("pdf", "png", "svg")
}


spectrum_tumor_file = paste0(spectrum_dir, "/tumor_TelomerCnt_", pid,"/", pid, ".spectrum")
spectrum_control_file = paste0(spectrum_dir, "/control_TelomerCnt_", pid,"/", pid, ".spectrum")

samples = c()
samples_short = c()
if (file.exists(spectrum_tumor_file)){samples = c(samples, "tumor"); samples_short = c(samples_short, "T")}
if (file.exists(spectrum_control_file)){samples = c(samples, "control"); samples_short = c(samples_short, "C")}



spectrum_summary_norm_list = list()

for (sample in samples){
  read_count_file = paste0(spectrum_dir, "/",sample, "_TelomerCnt_", pid, "/", pid, "_readcount.tsv")
  
  #get spectrum
  spectrum = read.table(paste0(spectrum_dir, "/",sample, "_TelomerCnt_", pid, "/", pid, ".spectrum"), header=TRUE, comment.char="")
  
  # make empty spectrum summary tables
  spectrum_summary = matrix(data=0, nrow=4, ncol=(ncol(spectrum)-2), byrow=TRUE)
  row.names(spectrum_summary)=c("intra_chromosomal", "subtelomeric", "junction_spanning", "intra_telomeric")
  colnames(spectrum_summary) = colnames(spectrum)[3:ncol(spectrum)]
  spectrum_summary = data.frame(spectrum_summary)
  
  
  # get intra-telomeric reads (= unmapped reads)
  spectrum_summary["intra_telomeric",] = spectrum[spectrum$chr=="unmapped",3:ncol(spectrum)]
  
  
  for (chr in c(1:22, "X", "Y")){
    spectrum_chr = spectrum[spectrum$chr==chr,3:ncol(spectrum)]
    
    # get junction spanning reads
    spectrum_summary["junction_spanning", ] = spectrum_summary["junction_spanning", ] + spectrum_chr[1,] + spectrum_chr[nrow(spectrum_chr),]
    
    # get subtelomeric reads (= first and last band)
    spectrum_summary["subtelomeric", ] = spectrum_summary["subtelomeric", ] + spectrum_chr[2,] + spectrum_chr[nrow(spectrum_chr)-1,]
    
    # get intra-chromosomal reads (= all other bands) 
    spectrum_summary["intra_chromosomal", ] = spectrum_summary["intra_chromosomal", ] + apply(spectrum_chr[3:(nrow(spectrum_chr)-2),], 2, sum)   
    
  }
  
  
  # get total number of reads 
  readcount = read.table(read_count_file, header=TRUE, comment.char="")
  total_reads = sum(as.numeric(readcount$reads))
  
  
  #normalize
  spectrum_summary_norm = spectrum_summary[,2:ncol(spectrum_summary)] * (spectrum_summary$reads_with_pattern / apply(spectrum_summary[ ,2:ncol(spectrum_summary)], 1,sum))
  spectrum_summary_norm = spectrum_summary_norm * (1000000 / total_reads)
  
  spectrum_summary_norm_list[[sample]] = spectrum_summary_norm
}



if (length(samples)==2){
  spectrum_summary = zipFastener(spectrum_summary_norm_list[["tumor"]], spectrum_summary_norm_list[["control"]], 1)
  axis=TRUE
  axis_simple=FALSE
}else{
  spectrum_summary = spectrum_summary_norm_list[[1]]
  axis=FALSE
  axis_simple=TRUE
}


height = t(spectrum_summary)
colnames(height) = NULL


plot_dir = file.path(spectrum_dir, "plots")

if (!(file.exists(plot_dir))){
  dir.create(plot_dir, recursive=TRUE)
}


if (nchar(pid)<11){
  main = paste0(pid,": Repeat Types in Telomeric Reads")
}else{
  main = paste0(pid,":\nRepeat Types in Telomeric Reads")
}


plot_file_prefix = paste0(plot_dir,"/", pid, "_summary")
barplot_repeattype(height=height,
                   plot_file_prefix=plot_file_prefix,
                   plot_file_format=plot_file_format,
                   plot_reverse_complement=plot_reverse_complement,
                   width=20,
                   main=main,
                   repeat_threshold=repeat_threshold, count_type=count_type, mapq_threshold=mapq_threshold,
                   sample_label=TRUE, sample_label_text=rep(samples_short,4),
                   axis=axis, axis_simple=axis_simple, labels=c("Intrachromosomal", "Subtelomeric", "Junction Spanning", "Intratelomeric"), 
                   xlas=1, tick=FALSE, cex.axis=0.85, cex.lab=0.9) 

# Description: contains functions for plotting scripts of TelomereHunter

# Copyright 2015 Lina Sieverling, Philip Ginsbach, Lars Feuerbach

# This file is part of TelomereHunter.

# TelomereHunter is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# TelomereHunter is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with TelomereHunter.  If not, see <http://www.gnu.org/licenses/>.



library(ggplot2)
library(reshape2)
library(grid)
library(gridExtra)
library(RColorBrewer)

# zipFastener for TWO dataframes of unequal length
zipFastener <- function(df1, df2, along=2)
{
  # parameter checking
  if(!is.element(along, c(1,2))){
    stop("along must be 1 or 2 for rows and columns
         respectively")
  }
  # if merged by using zip feeding along the columns, the
  # same no. of rows is required and vice versa
  if(along==1 & (ncol(df1)!= ncol(df2))) {
    stop ("the no. of columns has to be equal to merge
          them by zip feeding")
    }
    if(along==2 & (nrow(df1)!= nrow(df2))) {
        stop ("the no. of rows has to be equal to merge them by
              zip feeding")
    }

    # zip fastener preperations
    d1 <- dim(df1)[along]
    d2 <- dim(df2)[along]
    i1 <- 1:d1           # index vector 1
    i2 <- 1:d2 + d1      # index vector 2

    # set biggest dimension dMax
    if(d1==d2) {
        dMax <- d1
    } else if (d1 > d2) {
        length(i2) <- length(i1)    # make vectors same length, 
        dMax <- d1                  # fill blanks with NAs   
    } else  if(d1 < d2){
        length(i1) <- length(i2)    # make vectors same length,
        dMax <- d2                  # fill blanks with NAs   
    }
    
    # zip fastener operations
    index <- as.vector(matrix(c(i1, i2), ncol=dMax, byrow=T))
    index <- index[!is.na(index)]         # remove NAs
    
    if(along==1){
        colnames(df2) <- colnames(df1)   # keep 1st colnames                  
        res <- rbind(df1,df2)[ index, ]  # reorder data frame
    }
    if(along==2) res <- cbind(df1,df2)[ , index]           

    return(res)
}


# function for making bar plots
barplot_repeattype <- function (height,
                                plot_file_prefix, plot_file_format=c("pdf", "png", "svg"), width=550, mar=c(3.1, 5.1, 5.1, 9.3),
                                main, sub_title="", ylab="Telomere Reads (per Million Reads)",
                                plot_reverse_complement=FALSE,
                                repeat_threshold, count_type, mapq_threshold,
                                inset_legend=c(-0.34,0),    #legend.text=row.names(height)
                                sample_label=FALSE, sample_label_text=NA,
                                axis=TRUE, axis_simple=FALSE, labels=NA, xlas=2, tick=TRUE, cex.axis=1, cex.lab=1, cex.main=1.2, cex.names=1) {

  if (plot_reverse_complement==FALSE){
    height_patterns = as.matrix(height[1:(dim(height)[1]-1), ])
    height_summed = rowsum(height_patterns, group=rep(row.names(height_patterns)[seq(1, dim(height_patterns)[1], by=2)], each=2), reorder=FALSE)   
    height_summed = rbind(height_summed, height[dim(height)[1],])
    row.names(height_summed)[dim(height_summed)[1]] = "other"
    height = height_summed                         
  }

  searched_patterns = row.names(height)
  
  #get colors
  col_all = c("#CB181D", "#FF656A", "#74C476", "#C1FFC3", "#2171B5", "#6EBEFF", "#FFA500", "#FFF24D", "#9370DB", "#E0BDFF", "#000000")
  names(col_all) = c("TTAGGG", "CCCTAA", "TGAGGG", "CCCTCA", "TCAGGG", "CCCTGA", "TTGGGG", "CCCCAA",  "TTCGGG", "CCCGAA", "other")
  col=c(col_all[searched_patterns])  
  palette = colorRampPalette(brewer.pal(9, "Greys"))
  col[is.na(col)] = palette(sum(is.na(col))+2)[-c(1,sum(is.na(col))+2)]
  
  for (plot_type in plot_file_format){
    
    if (plot_type=="png"){png(paste0(plot_file_prefix,".png"), width=width, height=14, units="cm", res=300)}  
    if (plot_type=="pdf"){pdf(paste0(plot_file_prefix,".pdf"), width=width*0.4, height=14*0.4)}
    if (plot_type=="svg"){svg(paste0(plot_file_prefix, ".svg"), width=width/2.56, height=14/2.56)}
        
    par(mar=mar, xpd=TRUE)
    mp = barplot(height,
                 col=col,
                 main=main,
                 sub=sub_title,
                 ylab=ylab,
                 las=xlas,
                 cex.main=cex.main,
                 cex.axis=cex.axis,
                 cex.lab=cex.lab,
                 cex.names=cex.names,
                 border=NA)
    
    legend.title = paste(repeat_threshold, count_type, "Repeats", "\nMapq Threshold =", mapq_threshold)
    legend_pos = legend("topright", inset=inset_legend, title=legend.title, legend=searched_patterns, fill=col, bty="n", cex= 0.75, border="white")  
    
    xleft = legend_pos$rect[["left"]]
    ytop = legend_pos$rect[["top"]]
    ybottom = ytop - legend_pos$rect[["h"]]
    xright = xleft + legend_pos$rect[["w"]]
    rect(xleft, ybottom, xright, ytop+(ytop-ybottom)/(1.25*dim(height)[1]))
    
    if (sample_label==TRUE){
      text(x=mp, y=0, labels=sample_label_text, pos=1, cex=0.7)
    }

    
    if (axis==TRUE){
      mp2 = (mp[seq(1,length(mp),2)] + mp[seq(2,length(mp),2)]) / 2
      axis(1, labels=labels, at=mp2, las=xlas, tick=tick, cex.axis=cex.axis)
    } else if (axis_simple==TRUE){
      axis(1, labels=labels, at=mp, las=xlas, tick=tick, cex.axis=cex.axis)
    }
    
    garbage = dev.off()   # message from dev.off is not printed
  }
}




grid_arrange_shared_legend = function(plot_list, title, plot_file_prefix, plot_file_format=c("pdf", "png"), width=18, height=30) {

  for (plot_type in plot_file_format){
    
    if (plot_type=="png"){png(paste0(plot_file_prefix,".png"), width=width, height=height, units="cm", res=300)}  
    if (plot_type=="pdf"){pdf(paste0(plot_file_prefix,".pdf"), width=width*0.4, height=height*0.4)}
    if (plot_type=="svg"){svg(paste0(plot_file_prefix, ".svg"), width=width/2.56, height=height/2.56)}
      
    p = plot_list[[1]] + theme(legend.position="bottom") 
    g = ggplotGrob(p)$grobs
    legend = g[[which(sapply(g, function(x) x$name) == "guide-box")]]
    lheight = sum(legend$height)
    
    plot = arrangeGrob(
      do.call(arrangeGrob, lapply(plot_list, function(x)
        x + theme(legend.position="none"))),
      legend,
      ncol = 1,
      heights = unit.c(unit(1, "npc") - lheight, lheight),
      main=textGrob(title,gp=gpar(fontsize=20,font=2), vjust=0.7))
    
    grid::grid.draw(plot)


    invisible(dev.off())   # message from dev.off is not printed  
  }
}
